import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.*; 
import java.awt.image.*; 
import java.awt.event.*; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class EX31_08 extends PApplet {

float beginX = 20.0f;
float beginY = 10.0f;
float endX = 70.0f;
float endY = 80.0f;
float distX;
float distY;
float exponent = 3.0f;
float x = 0.0f;
float y = 0.0f;
float step = 0.01f;
float pct = 0.0f;
int direction = 1;

public void setup(){
  size(100,100);
  noStroke();
  smooth();
  distX = endX - beginX;
  distY = endY - beginY;
}

public void draw(){
  fill(0,2);
  rect(0,0,width,height);
  pct += step*direction;
  if ((pct>1.0f)||(pct<0.0f)){
    direction = direction*-1;
  }
  if (direction ==1 ){
    x = beginX + (pct*distX);
    float e = pow(pct, exponent);
    y = beginY + (e*distY);
  }else{
    x = beginX + (pct*distX);
    float e = pow (1.0f-pct, exponent*2);
    y = beginY + (e*-distY)+distY;
  }
  fill(255);
  ellipse(x,y,20,20);
}
  

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#ECE9D8", "EX31_08" });
  }
}
